import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Enemies here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Enemies extends Actor
{
    /**
     * Act - do whatever the Enemies wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private int vSpeed = 0;
    private int acceleration = 2;
    private int speed = 4;
    private int spriteHeight = getImage().getHeight();
    private int spriteWidth = getImage().getWidth();
    private int lookForGroundDistance = (int)spriteHeight/2;
    private int lookForEdge = (int)spriteWidth/2;
    
    private boolean movingLeft=false;
    private boolean movingRight=true;
    public void act() 
    {
        // Add your action code here.
        checkFall();
        move();
        catchPlayer();
    }
    
    public void move()
    {
        Actor ground = getOneObjectAtOffset(lookForEdge, lookForGroundDistance, Platform.class);
        if(ground == null)
        {        
            getImage().mirrorHorizontally();
            speed*=-1;
            lookForEdge*= -1;
        }else{
            move(speed);
        }
    }
    
    public void fall() //caer
    {
        setLocation(getX(),getY()+vSpeed);
        vSpeed=vSpeed+acceleration;
    }
    
    public boolean onGround() //está encima del suelo (plataforma)?
    {
        int spriteHeight = getImage().getHeight();
        int yDistance = (int) (spriteHeight/2+5);
        
        Actor ground = getOneObjectAtOffset(0,getImage().getHeight()/2, Platform.class);
        if(ground==null)
        {
            return false;
        }else{
            moveToGround(ground);
            return true;
        }
    }
    
    public void moveToGround(Actor ground)
    {
        int groundHeight = ground.getImage().getHeight();
        int newY = ground.getY()-(groundHeight+getImage().getHeight())/2;
        
        setLocation(getX(),newY);
    }
    
    public void checkFall() //comprobar si está cayendo
    {
        if(onGround()){ // si está sobre el suelo
            vSpeed=0; //velocidad vertical: 0
        }else{
            fall(); //sino: ¡me caigo!
        }
    }
    
    public void catchPlayer(){
        //sobreescribir
    }
    
    public boolean isMovingLeft(){
        return movingLeft;
    }
    
    public boolean isMovingRight(){
        return movingRight;
    }
    
    
}
