import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class General here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Leticia extends Player
{
    private int foods = 0;
    private boolean doStill = true;
    public void act() 
    {
        // Add your action code here.
        move();
        checkKey();
        checkFall();
        platformAbove();
        catchObject();
        settingImage();
        nextLevel();
    }
    
    @Override //redefinir método move() (esta vez se podrá mover hacia arriba y abajo)
    public void move(){
        /*int y=getY();
        if(Greenfoot.isKeyDown("up")){
            y-=4;
        }
        if(Greenfoot.isKeyDown("down")){
            y+=4;
        }*/
        if(Greenfoot.isKeyDown("left")){
            setMovingLeft(true);
            setMovingRight(false);
            move(-4);
        }
        if(Greenfoot.isKeyDown("right")){
            setMovingLeft(false);
            setMovingRight(true);
            move(4);
            settingImage();
        }
        
        //setLocation(getX(),y);
    }
    
    @Override
    public void settingImage(){
        if(isMovingLeft()){
            setImage("Leticia Nazareno L.png");
        }
        if(isMovingRight()){
            setImage("Leticia Nazareno R.png");
        }
    }
    
    public void catchObject() //capturar un objeto
    {
       Actor food = getOneIntersectingObject(Food.class); //analiza si hay un objeto de clase Bird que se cruce con el jugador
       if(doStill){       
           if(food!=null){ //si es diferente de null (es decir, si hay objetos) (null indica que no encontro nada) 
                getWorld().removeObject(food); //remueve el objeto
                Greenfoot.playSound("slurp.wav");
                placeNewFood();
                if(foods==15){
                    doStill = false;
                    MyGeneral myGeneral = new MyGeneral();
                    getWorld().addObject(myGeneral, 735, 525);
                    //Greenfoot.setWorld(new Level3()); //pasa de nivel
                }
                foods++;
            }
       }
    }
    
    public void placeNewFood(){
        World myWorld = getWorld();
        int x;
        int y;
        Actor food;
        x = Greenfoot.getRandomNumber(myWorld.getWidth()-80);
        y = Greenfoot.getRandomNumber(myWorld.getHeight()-80);
        food = new Food();
        getWorld().addObject(food, x, y);
    }
    
    public void nextLevel(){
        Actor general = getOneIntersectingObject(MyGeneral.class);
        if(foods>=15&&general!=null){
            Greenfoot.playSound("fanfare.wav");
            Greenfoot.setWorld(new L3());
        }
    }
    
}
